module copyTable_mod

  use dal
  use sasdal
  use errorhandling

  implicit none



  private
  public copyTable

contains

  subroutine copyTable(sourceDataSet, destDataSet, tableName)

    type(DataSetT) :: sourceDataSet, destDataSet
    type(TableT) :: sourceTable, destTable
    type(columnT) :: sourceCol   

    integer :: nrows, ncols, i
    character(len=20) :: colName
    
    character(len=*) :: tableName
    
    sourceTable = table(sourceDataSet,tableName)
    
    nrows = numberOfRows(sourceTable)
    ncols = numberOfColumns(sourceTable)
    
    destTable = addTable(destDataSet, tableName, nrows)
    
    do i = 0, ncols-1
       
       sourceCol = column(sourceTable, i, read)
!       colType = columnDataType(sourceCol)
       colName = name(sourceCol)
       call copyColumn( destTable, sourceCol, colName )
       call release(sourceCol)   
    
!       if (colType == Real32) then
!          write(*, *) "Line 49, column name=", colName
!          temp_r32 => real32Data(sourceCol)  
!          write(*, *) "Line 51"
!          destCol = addColumn(destTable, colName, colType, " ", shape(temp_r32))
!          temp2_r32 => real32Data(destCol)
!          temp2_r32 = temp_r32
!          call release(destCol)
!          call release(sourceCol)
!        else if (colType == Real64) then
      
!          temp_r64 => real64Data(sourceCol)  
!          destCol = addColumn(destTable, colName, colType, " ", shape(temp_r64))
!          temp2_r64 => real64Data(destCol)
!          temp2_r64 = temp_r64
!          call release(destCol)
!          call release(sourceCol)
    

!       else if (colType == Integer8) then
          
!          temp_i8 => int8Data(sourceCol)  
!          destCol = addColumn(destTable, colName, colType, " ", shape(temp_i8))
!          temp2_i8 => int8Data(destCol)
!          temp2_i8 = temp_i8
!          call release(destCol)
!          call release(sourceCol)
    
!       else if (colType == Integer16) then
          
!          temp_i16 => int16Data(sourceCol)  
!          destCol = addColumn(destTable, colName, colType, " ", shape(temp_i16))
!          temp2_i16 => int16Data(destCol)
!          temp2_i16 = temp_i16
!          call release(destCol)
!          call release(sourceCol)
    

!       else

          
!          call fatal("copyCol", "Cannot copy column")
          
!       endif

    end do

    call copyAllAttributes(attributable(sourceTable), attributable(destTable))
    call release(destTable)
    call release(sourceTable)
    
  end subroutine copyTable
  
end module copyTable_mod

